Index: src/molecules.cpp
===================================================================
--- src/molecules.cpp	(revision 260934983a76c25770b6a1f5706e2fc4eb1eecec)
+++ src/molecules.cpp	(revision db942effae4d25e57224c90078ac288434a4a783)
@@ -3733,54 +3512,73 @@
   } 
 
-  for (int BondOrder=1;BondOrder<=ANOVAOrder;BondOrder++) {
-    // this can easily be seen: if Order is 5, then the number of levels for each lower order is the total sum of the number of levels above, as
-    // each has to be split up. E.g. for the second level we have one from 5th, one from 4th, two from 3th (which in turn is one from 5th, one from 4th),
-    // hence we have overall four 2th order levels for splitting. This also allows for putting all into a single array (FragmentLowerOrdersList[])
-    // with the order along the cells as this: 5433222211111111 for BondOrder 5 needing 16=pow(2,5-1) cells (only we use bit-shifting which is faster)
-    NumLevels = 1 << (BondOrder-1); // (int)pow(2,BondOrder-1);
-    *out << Verbose(0) << "BondOrder is (" << BondOrder << "/" << ANOVAOrder << ") and NumLevels is " << NumLevels << "." << endl;
-  
+  // this can easily be seen: if Order is 5, then the number of levels for each lower order is the total sum of the number of levels above, as
+  // each has to be split up. E.g. for the second level we have one from 5th, one from 4th, two from 3th (which in turn is one from 5th, one from 4th),
+  // hence we have overall four 2th order levels for splitting. This also allows for putting all into a single array (FragmentLowerOrdersList[])
+  // with the order along the cells as this: 5433222211111111 for BondOrder 5 needing 16=pow(2,5-1) cells (only we use bit-shifting which is faster)
+  RootNr = 0;   // counts through the roots in RootStack
+  while (RootNr < UpgradeCount) {
+    RootKeyNr = RootStack.front();
+    RootStack.pop_front();
+    // increase adaptive order by one
+    Walker = FindAtom(RootKeyNr);
+    Walker->GetTrueFather()->AdaptiveOrder++;
+    Order = Walker->AdaptiveOrder = Walker->GetTrueFather()->AdaptiveOrder;
+    
     // allocate memory for all lower level orders in this 1D-array of ptrs
-    FragmentLowerOrdersList[BondOrder-1] = (Graph **) Malloc(sizeof(Graph *)*NumLevels, "molecule::FragmentBOSSANOVA: **FragmentLowerOrdersList[]");
+    NumLevels = 1 << (Order); // (int)pow(2,Order);
+    FragmentLowerOrdersList[RootNr] = (Graph **) Malloc(sizeof(Graph *)*NumLevels, "molecule::FragmentBOSSANOVA: **FragmentLowerOrdersList[]");
   
     // create top order where nothing is reduced
     *out << Verbose(0) << "==============================================================================================================" << endl;
-    *out << Verbose(0) << "Creating list of unique fragments of Bond Order " << BondOrder << " itself." << endl;
+    *out << Verbose(0) << "Creating KeySets of Bond Order " << Order << " for " << *Walker << ", NumLevels is " << NumLevels << ", " << RootStack.size() << " Roots remaining." << endl;
+
     // Create list of Graphs of current Bond Order (i.e. F_{ij})
-    FragmentLowerOrdersList[BondOrder-1][0] =  new Graph;
-    NumMoleculesOfOrder[BondOrder-1] = CreateListOfUniqueFragmentsOfOrder(out, BondOrder, FragmentLowerOrdersList[BondOrder-1][0], CompleteMolecule, 1., configuration);
-    *out << Verbose(1) << "Number of resulting molecules is: " << NumMoleculesOfOrder[BondOrder-1] << "." << endl;
+    FragmentLowerOrdersList[RootNr][0] =  new Graph;
+    NumMoleculesOfOrder[RootNr] = PowerSetGenerator(out, Walker->AdaptiveOrder, FragmentLowerOrdersList[RootNr][0], CompleteMolecule, RootKeyNr);
+    *out << Verbose(1) << "Number of resulting KeySets is: " << NumMoleculesOfOrder[RootNr] << "." << endl;
     NumMolecules = 0;
     
-    // create lower order fragments
-    *out << Verbose(0) << "Creating list of unique fragments of lower Bond Order terms to be subtracted." << endl;
-    Order = BondOrder;
-    for (int source=0;source<(NumLevels >> 1);source++) { // 1-terms don't need any more splitting, that's why only half is gone through (shift again)
-
-      // step down to next order at (virtual) boundary of powers of 2 in array
-      while (source >= (1 << (BondOrder-Order))) // (int)pow(2,BondOrder-Order))    
-        Order--;
-      *out << Verbose(0) << "Current Order is: " << Order << "." << endl;
-      for (int SubOrder=Order;SubOrder>1;SubOrder--) {
-        int dest = source + (1 << (BondOrder-SubOrder));
-        *out << Verbose(0) << "--------------------------------------------------------------------------------------------------------------" << endl;
-        *out << Verbose(0) << "Current SubOrder is: " << SubOrder-1 << " with source " << source << " to destination " << dest << "." << endl;
-  
-        // every molecule is split into a list of again (Order - 1) molecules, while counting all molecules
-        //*out << Verbose(1) << "Splitting the " << (*FragmentLowerOrdersList[BondOrder-1][source]).size() << " molecules of the " << source << "th cell in the array." << endl;
-        //NumMolecules = 0;
-        FragmentLowerOrdersList[BondOrder-1][dest] = new Graph;
-        for(Graph::iterator runner = (*FragmentLowerOrdersList[BondOrder-1][source]).begin();runner != (*FragmentLowerOrdersList[BondOrder-1][source]).end(); runner++) {
-          NumMolecules += CreateListOfUniqueFragmentsOfOrder(out,SubOrder-1, FragmentLowerOrdersList[BondOrder-1][dest], (*runner).first, -(*runner).second.second, configuration);
+    if ((NumLevels >> 1) > 0) {
+      // create lower order fragments
+      *out << Verbose(0) << "Creating list of unique fragments of lower Bond Order terms to be subtracted." << endl;
+      Order = Walker->AdaptiveOrder;
+      for (int source=0;source<(NumLevels >> 1);source++) { // 1-terms don't need any more splitting, that's why only half is gone through (shift again)
+        // step down to next order at (virtual) boundary of powers of 2 in array
+        while (source >= (1 << (Walker->AdaptiveOrder-Order))) // (int)pow(2,Walker->AdaptiveOrder-Order))    
+          Order--;
+        *out << Verbose(0) << "Current Order is: " << Order << "." << endl;
+        for (int SubOrder=Order;SubOrder>1;SubOrder--) {
+          int dest = source + (1 << (Walker->AdaptiveOrder-SubOrder));
+          *out << Verbose(0) << "--------------------------------------------------------------------------------------------------------------" << endl;
+          *out << Verbose(0) << "Current SubOrder is: " << SubOrder-1 << " with source " << source << " to destination " << dest << "." << endl;
+    
+          // every molecule is split into a list of again (Order - 1) molecules, while counting all molecules
+          //*out << Verbose(1) << "Splitting the " << (*FragmentLowerOrdersList[RootNr][source]).size() << " molecules of the " << source << "th cell in the array." << endl;
+          //NumMolecules = 0;
+          FragmentLowerOrdersList[RootNr][dest] = new Graph;
+          for(Graph::iterator runner = (*FragmentLowerOrdersList[RootNr][source]).begin();runner != (*FragmentLowerOrdersList[RootNr][source]).end(); runner++) {
+            for (KeySet::iterator sprinter = (*runner).first.begin();sprinter != (*runner).first.end(); sprinter++) {
+              FragmentList = new Graph();
+              PowerSetGenerator(out, SubOrder-1, FragmentList, (*runner).first, *sprinter);
+              // insert new keysets FragmentList into FragmentLowerOrdersList[Walker->AdaptiveOrder-1][dest]
+              *out << Verbose(1) << "Merging resulting key sets with those present in destination " << dest << "." << endl;
+              InsertGraphIntoGraph(out, *FragmentLowerOrdersList[RootNr][dest], *FragmentList, &NumMolecules);
+              delete(FragmentList);
+            }
+          }
+          *out << Verbose(1) << "Number of resulting molecules for SubOrder " << SubOrder << " is: " << NumMolecules << "." << endl;
         }
-        *out << Verbose(1) << "Number of resulting molecules is: " << NumMolecules << "." << endl;
-      }
-    }
-    // now, we have completely filled each cell of FragmentLowerOrdersList[] for the current BondOrder
-    //NumMoleculesOfOrder[BondOrder-1] = NumMolecules;
-    TotalNumMolecules += NumMoleculesOfOrder[BondOrder-1];
-    *out << Verbose(1) << "Number of resulting molecules for Order " << BondOrder << " is: " << NumMoleculesOfOrder[BondOrder-1] << "." << endl;    
-  }
+      }
+    }
+    // now, we have completely filled each cell of FragmentLowerOrdersList[] for the current Walker->AdaptiveOrder
+    //NumMoleculesOfOrder[Walker->AdaptiveOrder-1] = NumMolecules;
+    TotalNumMolecules += NumMoleculesOfOrder[RootNr];
+    *out << Verbose(1) << "Number of resulting molecules for Order " << Walker->AdaptiveOrder << " is: " << NumMoleculesOfOrder[RootNr] << "." << endl;
+    RootStack.push_back(RootKeyNr); // put back on stack
+    RootNr++;
+  }
+  *out << Verbose(0) << "==============================================================================================================" << endl;
   *out << Verbose(1) << "Total number of resulting molecules is: " << TotalNumMolecules << "." << endl;
+  *out << Verbose(0) << "==============================================================================================================" << endl;
   // now, FragmentLowerOrdersList is complete, it looks - for BondOrder 5 - as this (number is the ANOVA Order of the terms therein) 
   // 5433222211111111
@@ -3789,15 +3587,20 @@
   // 21
   // 1
-  // Subsequently, we combine same orders into a single list (FragmentByOrderList) and reduce these by order
+  // Subsequently, we combine all into a single list (FragmentList)
 
   *out << Verbose(0) << "Combining the lists of all orders per order and finally into a single one." << endl;
   FragmentList = new Graph;
-  for (int BondOrder=1;BondOrder<=ANOVAOrder;BondOrder++) {
-    NumLevels = 1 << (BondOrder-1);
+  RootNr = 0;
+  while (!RootStack.empty()) {
+    RootKeyNr = RootStack.front();
+    RootStack.pop_front();
+    Walker = FindAtom(RootKeyNr); 
+    NumLevels = 1 << (Walker->AdaptiveOrder - 1);
     for(int i=0;i<NumLevels;i++) {
-      InsertGraphIntoGraph(out, *FragmentList, (*FragmentLowerOrdersList[BondOrder-1][i]), &counter);
-      delete(FragmentLowerOrdersList[BondOrder-1][i]);
-    }
-    Free((void **)&FragmentLowerOrdersList[BondOrder-1], "molecule::FragmentBOSSANOVA: **FragmentLowerOrdersList[]");
+      InsertGraphIntoGraph(out, *FragmentList, (*FragmentLowerOrdersList[RootNr][i]), &counter);
+      delete(FragmentLowerOrdersList[RootNr][i]);
+    }
+    Free((void **)&FragmentLowerOrdersList[RootNr], "molecule::FragmentBOSSANOVA: **FragmentLowerOrdersList[]");
+    RootNr++;
   }
   Free((void **)&FragmentLowerOrdersList, "molecule::FragmentBOSSANOVA: ***FragmentLowerOrdersList");
@@ -3807,110 +3610,4 @@
   return FragmentList;
 };
-
-/** Fragments a molecule, taking \a BondDegree neighbours into accent.
- * First of all, we have to split up the molecule into bonds ranging out till \a BondDegree.
- * These fragments serve in the following as the basis the calculate the bond energy of the bond
- * they originated from. Thus, they are split up in a left and a right part, each calculated for
- * the total energy, including the fragment as a whole and then we get: 
- * E(fragment) - E(left) - E(right) = E(bond)
- * The splitting up is done via Breadth-First-Search, \sa BreadthFirstSearchAdd().
- * \param *out output stream for debugging
- * \param BondOrder up to how many neighbouring bonds a fragment contains
- * \param *configuration configuration for writing config files for each fragment
- * \param CutCyclic whether to add cut cyclic bond or to saturate
- * \return pointer to MoleculeListClass with all the fragments or NULL if something went wrong.
- */
-MoleculeListClass * molecule::FragmentBottomUp(ofstream *out, int BondOrder, config *configuration, enum CutCyclicBond CutCyclic)
-{
-  int Num;
-  MoleculeListClass *FragmentList =  NULL, **FragmentsList = NULL;
-  bond *Bond = NULL;
-
-  *out << Verbose(0) << "Begin of FragmentBottomUp." << endl; 
-  FragmentsList = (MoleculeListClass **) Malloc(sizeof(MoleculeListClass *)*2, "molecule::FragmentBottomUp: **FragmentsList");
-  *out << Verbose(0) << "Getting Atomic fragments." << endl;
-  FragmentsList[0] = GetAtomicFragments(out, AtomCount, configuration->GetIsAngstroem(), 1., CutCyclic);
-
-  // create the fragments including each one bond of the original molecule and up to \a BondDegree neighbours
-  *out << Verbose(0) << "Getting " << 
-#ifdef ADDHYDROGEN  
-  NoNonBonds 
-#else
-  BondCount
-#endif
-                                        << " Bond fragments." << endl;
-  FragmentList = GetEachBondFragmentOfOrder(out, BondOrder, configuration->GetIsAngstroem(), CutCyclic);
-
-  // check whether there are equal fragments by ReduceToUniqueOnes
-  FragmentList->ReduceToUniqueList(out, &cell_size[0], BondDistance);
-
-	*out << Verbose(0) << "Begin of Separating " << FragmentList->NumberOfMolecules << " Fragments into Bond pieces." << endl;
-	// as we have the list, we have to take each fragment split it relative to its originating
-	// bond into left and right and store these in a new list
-  *out << Verbose(2) << endl << "Allocating MoleculeListClass" << endl; 
-  FragmentsList[1] =  new MoleculeListClass(3*FragmentList->NumberOfMolecules, AtomCount); // for each molecule the whole and its left and right part 
-  *out << Verbose(2) << "Creating TEList." << endl; 
-  // and create TE summation for these bond energy approximations (bond = whole - left - right)
-  for(int i=0;i<FragmentList->NumberOfMolecules;i++) {
-    // make up factors to regain total energy of whole molecule
-    FragmentsList[1]->TEList[3*i] = FragmentList->TEList[i];       // bond energy is 1 * whole 
-    FragmentsList[1]->TEList[3*i+1] = -FragmentList->TEList[i];    // - 1. * left part
-    FragmentsList[1]->TEList[3*i+2] = -FragmentList->TEList[i];    // - 1. * right part
-
-    // shift the pointer on whole molecule to new list in order to avoid that this molecule is deleted on deconstructing FragmentList
-    FragmentsList[1]->ListOfMolecules[3*i] = FragmentList->ListOfMolecules[i]; 
-    *out << Verbose(2) << "shifting whole fragment pointer for fragment " << FragmentList->ListOfMolecules[i] << " -> " <<  FragmentsList[1]->ListOfMolecules[3*i] << "." << endl;
-    // create bond matrix and count bonds
-    *out << Verbose(2) << "Updating bond list for fragment " << i << " [" << FragmentList << "]: " << FragmentList->ListOfMolecules[i] << endl; 
-    // create list of bonds per atom for this fragment (atoms were counted above)
-    FragmentsList[1]->ListOfMolecules[3*i]->CreateListOfBondsPerAtom(out);
-     
-    *out << Verbose(0) << "Getting left & right fragments for fragment " << i << "." << endl;
-    // the bond around which the fragment has been setup is always the first by construction (bond partners are first added atoms)
-    Bond = FragmentsList[1]->ListOfMolecules[3*i]->first->next; // is the bond between atom 0 and another in the middle
-    FragmentsList[1]->ListOfMolecules[3*i]->FragmentMoleculeByBond(out, Bond, &(FragmentsList[1]->ListOfMolecules[3*i+1]), &(FragmentsList[1]->ListOfMolecules[3*i+2]), configuration->GetIsAngstroem(), CutCyclic);
-    if ((FragmentsList[1]->ListOfMolecules[3*i+1] == NULL) || (FragmentsList[1]->ListOfMolecules[3*i+2] == NULL)) {
-      *out << Verbose(2) << "Left and/or Right Fragment is NULL!" << endl;
-    } else {
-      *out << Verbose(3) << "Left Fragment is " <<  FragmentsList[1]->ListOfMolecules[3*i+1] << ": " << endl;
-      FragmentsList[1]->ListOfMolecules[3*i+1]->Output(out);
-      *out << Verbose(3) << "Right Fragment is " <<  FragmentsList[1]->ListOfMolecules[3*i+2] << ": " << endl;
-      FragmentsList[1]->ListOfMolecules[3*i+2]->Output(out);
-      *out << endl;
-    }
-    // remove in old list, so that memory for this molecule is not free'd on final delete of this list
-    FragmentList->ListOfMolecules[i] = NULL;
-  }
-	*out << Verbose(0) << "End of Separating Fragments into Bond pieces." << endl;
-  delete(FragmentList);
-  FragmentList = NULL;
-
-  // combine atomic and bond list
-  FragmentList = new MoleculeListClass(FragmentsList[0]->NumberOfMolecules + FragmentsList[1]->NumberOfMolecules, AtomCount);
-  Num = 0;
-  for(int i=0;i<2;i++) {
-    for(int j=0;j<FragmentsList[i]->NumberOfMolecules;j++) {
-      // transfer molecule
-      FragmentList->ListOfMolecules[Num] = FragmentsList[i]->ListOfMolecules[j];
-      FragmentsList[i]->ListOfMolecules[j] = NULL;
-      // transfer TE factor
-      FragmentList->TEList[Num] = FragmentsList[i]->TEList[j];
-      Num++;
-    }
-    delete(FragmentsList[i]);
-    FragmentsList[i] = NULL;
-  }
-  *out << Verbose(2) << "Memory cleanup and return with filled list." << endl; 
-  Free((void **)&FragmentsList, "molecule::FragmentBottomUp: **FragmentsList");
-
-  // reducing list
-  FragmentList->ReduceToUniqueList(out, &cell_size[0], BondDistance);
-	
-	// write configs for all fragements (are written in FragmentMolecule)
-  // free FragmentList
-  *out << Verbose(0) << "End of FragmentBottomUp." << endl; 
-  return FragmentList;
-};
-
 
 /** Comparision function for GSL heapsort on distances in two molecules.
Index: src/molecules.hpp
===================================================================
--- src/molecules.hpp	(revision 260934983a76c25770b6a1f5706e2fc4eb1eecec)
+++ src/molecules.hpp	(revision db942effae4d25e57224c90078ac288434a4a783)
@@ -356,4 +356,5 @@
     int LowpointNr; //!< needed in DepthFirstSearchAnalysis() to detect nonseparable components, is the lowest possible number of an atom to reach via tree edges only followed by at most one back edge.
     bool SeparationVertex; //!< whether this atom separates off subsets of atoms or not, given in DepthFirstSearchAnalysis()
+    unsigned char AdaptiveOrder;  //!< current present bond order at site (0 means "not set")
   
   atom();
@@ -519,19 +520,15 @@
   
   /// Fragment molecule by two different approaches:
-  void FragmentMolecule(ofstream *out, int BottomUpOrder, int TopDownOrder, enum BondOrderScheme Scheme, config *configuration, enum CutCyclicBond CutCyclic);
-  bool StoreAdjacencyToFile(ofstream *out, char *path, int bondorder);
-  bool CheckAdjacencyFileAgainstMolecule(ofstream *out, char *path, atom **ListOfAtoms, int bondorder);
+  void FragmentMolecule(ofstream *out, int Order, config *configuration);
+  bool StoreAdjacencyToFile(ofstream *out, char *path);
+  bool CheckAdjacencyFileAgainstMolecule(ofstream *out, char *path, atom **ListOfAtoms);
+  bool ParseOrderAtSiteFromFile(ofstream *out, char *path);
+  bool StoreOrderAtSiteFile(ofstream *out, char *path);
   bool ParseKeySetFile(ofstream *out, char *filename, atom **ListOfAtoms, MoleculeListClass *&FragmentList, bool IsAngstroem);
   bool ScanBufferIntoKeySet(ofstream *out, char *buffer, KeySet &CurrentSet);
-  MoleculeListClass * GetAtomicFragments(ofstream *out, int NumberOfTopAtoms, bool IsAngstroem, double factor, enum CutCyclicBond CutCyclic);
-  void BreadthFirstSearchAdd(ofstream *out, molecule *Mol, atom **&AddedAtomList, bond **&AddedBondList, atom *Root, bond *Bond, int BondOrder, bool IsAngstroem, enum CutCyclicBond CutCyclic);
-  /// -# BottomUp  
-  MoleculeListClass * FragmentBottomUp(ofstream *out, int BondOrder, config *configuration, enum CutCyclicBond CutCyclic);
-  MoleculeListClass * GetEachBondFragmentOfOrder(ofstream *out, int BondOrder, bool IsAngstroem, enum CutCyclicBond CutCyclic);
-  /// -# TopDown
-  void FragmentMoleculeByBond(ofstream *out, bond *Bond, molecule **LeftFragment, molecule **RightFragment, bool IsAngstroem, enum CutCyclicBond CutCyclic);
+  void BreadthFirstSearchAdd(ofstream *out, molecule *Mol, atom **&AddedAtomList, bond **&AddedBondList, atom *Root, bond *Bond, int BondOrder, bool IsAngstroem);
   /// -# BOSSANOVA
-  Graph * FragmentBOSSANOVA(ofstream *out, int ANOVAOrder, config *configuration);
-	int CreateListOfUniqueFragmentsOfOrder(ofstream *out, int Order, Graph *ListOfGraph, KeySet Fragment, double TEFactor, config *configuration);
+  Graph * FragmentBOSSANOVA(ofstream *out, KeyStack &RootStack);
+	int PowerSetGenerator(ofstream *out, int Order, Graph *ReturnKeySets, KeySet RestrictedKeySet, int RootKeyNr);
   bool BuildInducedSubgraph(ofstream *out, const molecule *Father);
   molecule * StoreFragmentFromKeySet(ofstream *out, KeySet &Leaflet, bool IsAngstroem);
@@ -560,5 +557,4 @@
     int NumberOfMolecules;        //!< Number of entries in \a **FragmentList and of to be returned one.
     int NumberOfTopAtoms;         //!< Number of atoms in the molecule from which all fragments originate
-    double *TEList;               //!< List of factors when summing over total energies of all fragment
     
   MoleculeListClass();
@@ -566,13 +562,6 @@
   ~MoleculeListClass();
 
-  MoleculeListClass * FragmentTopDown(ofstream *out, int BondDegree, double bonddistance, config *configuration, enum CutCyclicBond Saturation);
-
-  /// Reduced list to unique molecules.
-  int * GetMappingToUniqueFragments(ofstream *out, double threshold, double *cell_size, double celldistance);
-  int ReduceFragmentToUniqueOnes(ofstream *out, int *Map);
-  void ReduceToUniqueList(ofstream *out, double *cell_size, double celldistance);
-
   /// Output configs.
-  bool OutputConfigForListOfFragments(char *prefix, config *configuration, int *SortIndex);
+  bool OutputConfigForListOfFragments(ofstream *out, config *configuration, int *SortIndex);
   void Output(ofstream *out);
   
Index: src/parser.cpp
===================================================================
--- src/parser.cpp	(revision 260934983a76c25770b6a1f5706e2fc4eb1eecec)
+++ src/parser.cpp	(revision db942effae4d25e57224c90078ac288434a4a783)
@@ -43,5 +43,5 @@
   stringstream line;
 
-  line << argv[1] << FRAGMENTPREFIX << TEFACTORSFILE;
+  //line << argv[1] << FRAGMENTPREFIX << TEFACTORSFILE;
   return FilePresent(line.str().c_str());
 };
@@ -106,5 +106,5 @@
   // count the number of matrices
   MatrixCounter = -1; // we count one too much
-  line << name << FRAGMENTPREFIX << TEFACTORSFILE;
+  line << name << FRAGMENTPREFIX << KEYSETFILE;
   input.open(line.str().c_str(), ios::in);
   if (input == NULL) {
@@ -417,33 +417,10 @@
 bool ForceMatrix::ParseIndices(char *name) 
 {
-  ifstream input;
-  char *FragmentNumber = NULL;
-  char filename[1023];
-  stringstream line;
-  
   cout << "Parsing force indices." << endl;
   Indices = (int **) Malloc(sizeof(int *)*(MatrixCounter+1), "ForceMatrix::ParseIndices: **Indices");
-  line << name << FRAGMENTPREFIX << FORCESFILE;
-  input.open(line.str().c_str(), ios::in);
-  //cout << "Opening " << line.str() << " ... "  << input << endl;
-  if (input == NULL) {
-    cout << endl << "Unable to open " << line.str() << ", is the directory correct?" << endl;
-    return false;
-  }
-  for (int i=0;(i<MatrixCounter) && (!input.eof());i++) {
-    // get the number of atoms for this fragment
-    stringstream line;
-    input.getline(filename, 1023);
-    line.str(filename);
-    // parse the values
+  for (int i=0;i<MatrixCounter;i++) {
     Indices[i] = (int *) Malloc(sizeof(int)*RowCounter[i], "ForceMatrix::ParseIndices: *Indices[]");
-    FragmentNumber = FixedDigitNumber(MatrixCounter, i);
-    cout << FRAGMENTPREFIX << FragmentNumber << "[" << RowCounter[i] << "]:";
-    Free((void **)&FragmentNumber, "ForceMatrix::ParseIndices: *FragmentNumber");
-    for(int j=0;(j<RowCounter[i]) && (!line.eof());j++) {
-      line >> Indices[i][j];
-      cout << " " << Indices[i][j];
-    }
-    cout << endl;
+    for(int j=0;j<RowCounter[i];j++)
+      Indices[i][j] = j;
   }
   Indices[MatrixCounter] = (int *) Malloc(sizeof(int)*RowCounter[MatrixCounter], "ForceMatrix::ParseIndices: *Indices[]");
@@ -451,5 +428,4 @@
     Indices[MatrixCounter][j] = j;
   }
-  input.close();
   return true;
 };
Index: src/vector.cpp
===================================================================
--- src/vector.cpp	(revision 260934983a76c25770b6a1f5706e2fc4eb1eecec)
+++ src/vector.cpp	(revision db942effae4d25e57224c90078ac288434a4a783)
@@ -78,8 +78,8 @@
   //vector Shifted, TranslationVector;
   vector TestVector;
-  *out << Verbose(1) << "Begin of KeepPeriodic." << endl;
-  *out << Verbose(2) << "Vector is: ";
-  Output(out);
-  *out << endl;
+//  *out << Verbose(1) << "Begin of KeepPeriodic." << endl;
+//  *out << Verbose(2) << "Vector is: ";
+//  Output(out);
+//  *out << endl;
   TestVector.CopyVector(this);
   TestVector.InverseMatrixMultiplication(matrix);
@@ -93,8 +93,8 @@
   TestVector.MatrixMultiplication(matrix);
   CopyVector(&TestVector);
-  *out << Verbose(2) << "New corrected vector is: ";
-  Output(out);
-  *out << endl;
-  *out << Verbose(1) << "End of KeepPeriodic." << endl;
+//  *out << Verbose(2) << "New corrected vector is: ";
+//  Output(out);
+//  *out << endl;
+//  *out << Verbose(1) << "End of KeepPeriodic." << endl;
 };
 
